//+------------------------------------------------------------------+
//|                                       asymmetric ema bands 1.mq4 |
//| forex-tsd elite section only                                     |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property indicator_separate_window
#property indicator_buffers  6
//---
#property indicator_color1   clrCornflowerBlue  //DeepSkyBlue
#property indicator_color2   clrMediumOrchid  //PaleVioletRed
#property indicator_color3   clrLightSkyBlue  //LightCyan  //Orange
#property indicator_color4   clrOrchid  //Magenta  //DeepSkyBlue
#property indicator_color5   clrLime  //PaleVioletRed
#property indicator_color6   clrRed  //DimGray
//---
#property indicator_style5   STYLE_SOLID
#property indicator_style6   STYLE_DOT
#property indicator_width3   2
#property indicator_width4   2
#property indicator_width5   2
#property indicator_width6   2
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
enum setCLR { ColorOFF, hstMAIN, hstZERO, lnMAIN, lnZERO };
//+------------------------------------------------------------------+
extern int                ABPeriod    = 24;  //12;  //288
extern ENUM_MA_METHOD     ABMode      = MODE_EMA;
extern ENUM_APPLIED_PRICE ABPrice     = PRICE_CLOSE;
extern double             ABDeviation = 1.618;
extern double             LEVEL       = 1.0;
extern setCLR             DoubleColor = hstZERO;  //lnZERO;
extern double             ZeroK       = 1.0;
//+------------------------------------------------------------------+
double LevelLO[], LevelHI[];
double clrBUY[], clrSELL[];
double MAIN[], ZERO[];
double maBuffer[];
double wuBuffer[];
double wdBuffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   ABPeriod = fmax(ABPeriod,2);
   ZeroK = fmax(ZeroK,1);
//---
   IndicatorBuffers(9);   IndicatorDigits(1);
   //---
      SetIndexBuffer(0,LevelLO);  SetIndexStyle(0,DRAW_LINE);  SetIndexDrawBegin(0,ABPeriod);    SetIndexLabel(0,"LevLO  -"+DoubleToStr(LEVEL,1));
      SetIndexBuffer(1,LevelHI);  SetIndexStyle(1,DRAW_LINE);  SetIndexDrawBegin(1,ABPeriod);    SetIndexLabel(1,"LevHI  +"+DoubleToStr(LEVEL,1));
      //---
      int CLT = (DoubleColor==3 || DoubleColor==4) ? DRAW_LINE : DRAW_HISTOGRAM;
      SetIndexBuffer(2,clrBUY);   SetIndexStyle(2,CLT);  SetIndexDrawBegin(2,ABPeriod);          SetIndexLabel(2,"BUY");
      SetIndexBuffer(3,clrSELL);  SetIndexStyle(3,CLT);  SetIndexDrawBegin(3,ABPeriod);          SetIndexLabel(3,"SELL");
      //---  ////enum setCLR { ColorOFF, hstMAIN, hstZERO, lnMAIN, lnZERO };
      int MLT = (DoubleColor==0 || DoubleColor==2 || DoubleColor==4) ? DRAW_LINE : DRAW_NONE;
      SetIndexBuffer(4,MAIN);  SetIndexStyle(4,MLT);  SetIndexDrawBegin(4,ABPeriod);             SetIndexLabel(4,"AB "+StringSubstr(EnumToString(ABMode),5,0)+" ["+(string)ABPeriod+"*"+DoubleToStr(ABDeviation,3)+"]"); 
      int ZLT = (DoubleColor==0 || DoubleColor==1 || DoubleColor==3) ? DRAW_LINE : DRAW_NONE;    SetIndexLabel(5,"ZERO LINE");
      SetIndexBuffer(5,ZERO);  SetIndexStyle(5,ZLT);  SetIndexDrawBegin(5,ABPeriod);
      //---
      SetIndexBuffer(6,maBuffer);
      SetIndexBuffer(7,wuBuffer);
      SetIndexBuffer(8,wdBuffer);
   //---
   IndicatorShortName("Asymetric "+StringSubstr(EnumToString(ABMode),5,0)+" Deviation Oscillator ["+(string)ABPeriod+"*"+DoubleToStr(ABDeviation,3)+"]"); 
//---
return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   double alpha = 2.0 / (1.0 + ABPeriod);
   double coeff = (ABPeriod-1.0)/ABPeriod;
   //---
   int i,limit,CountedBars=IndicatorCounted();
   if (CountedBars<0) return(-1);
   if (CountedBars>0) CountedBars--;
   limit = MathMin(Bars-CountedBars,Bars-1);
         
   //
            
   for (i=limit; i>=0; i--)
    {
     double price = iMA(NULL,0,1,0,MODE_SMA,ABPrice,i);
     maBuffer[i]  = iMA(NULL,0,ABPeriod,0,ABMode,ABPrice,i);
     //---
       double diff = price-maBuffer[i];
       double edev = iEDev(price,ABPeriod,i);
       if (maBuffer[i]  ==0) continue;
       if (maBuffer[i+1]==0)
        {
         LevelHI[i] = maBuffer[i];
         LevelLO[i] = maBuffer[i];
         if (diff>=0)
               { wuBuffer[i] = edev; wdBuffer[i] = 0; }
         else  { wdBuffer[i] = edev; wuBuffer[i] = 0; }                  
         continue;
        }
     //---
       if (diff>=0)
            { wuBuffer[i] = edev; wdBuffer[i] = wdBuffer[i+1]+alpha*(wdBuffer[i+1]*coeff-wdBuffer[i+1]); }
       else { wdBuffer[i] = edev; wuBuffer[i] = wuBuffer[i+1]+alpha*(wuBuffer[i+1]*coeff-wuBuffer[i+1]); }
       
       double range = ABDeviation*(wuBuffer[i]+wdBuffer[i]);
       
          ZERO[i] = (2.0*(ABDeviation*wdBuffer[i])/range-1.0) *ZeroK;
          MAIN[i] = 2.0*(ABDeviation*wdBuffer[i]+price-maBuffer[i])/range-1.0;
          //---
          LevelLO[i] =  -LEVEL;
          LevelHI[i] =   LEVEL;
       //--- ////enum setCLR { ColorOFF, hstMAIN, hstZERO, lnMAIN, lnZERO };
       if (DoubleColor==1) setupCOLOR(false,MAIN,ZERO,clrBUY,clrSELL,i);
       if (DoubleColor==2) setupCOLOR(false,ZERO,MAIN,clrSELL,clrBUY,i);
       if (DoubleColor==3) setupCOLOR(true,MAIN,ZERO,clrBUY,clrSELL,i);
       if (DoubleColor==4) setupCOLOR(true,ZERO,MAIN,clrSELL,clrBUY,i);
    }
//---
return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double edevWork[][2];
//------
double iEDev(double price, double period, int i)
{
   if (ArrayRange(edevWork,0)!=Bars) ArrayResize(edevWork,Bars);
   //---
   int    r     = Bars-i-1;
   double alpha = 2.0/(1.0+period);
   //---
      edevWork[r][0] = edevWork[r-1][0]+alpha*(price      -edevWork[r-1][0]);
      edevWork[r][1] = edevWork[r-1][1]+alpha*(price*price-edevWork[r-1][1]);
   //---
return(MathSqrt((period*edevWork[r][1]-period*edevWork[r][0]*edevWork[r][0])/(period-1.0)));
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double trend[];
//------
void setupCOLOR(bool IfLine, double& main[], double& zero[], double& trendUP[], double& trendDN[], int i)
{
   if (ArrayRange(trend,0)!=Bars)  ArrayResize(trend,Bars);
   trendUP[i]=EMPTY_VALUE;  trendDN[i]=EMPTY_VALUE; 
   //------
   trend[i] = trend[i+1];    
   //------
   if (main[i] > zero[i]) trend[i] = 888;        
   if (main[i] < zero[i]) trend[i] = -888;
   //------
   if (IfLine) {
       if (trend[i]>0) { trendUP[i]=main[i];  if (trend[i+1]<0) trendUP[i+1]=main[i+1];  trendDN[i]=EMPTY_VALUE; }     
       if (trend[i]<0) { trendDN[i]=main[i];  if (trend[i+1]>0) trendDN[i+1]=main[i+1];  trendUP[i]=EMPTY_VALUE; } }
   //------
   if (!IfLine) {
       if (trend[i]>0) { trendUP[i]=main[i];  trendDN[i]=EMPTY_VALUE; }     
       if (trend[i]<0) { trendDN[i]=main[i];  trendUP[i]=EMPTY_VALUE; } }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+